﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using NServiceBus;
using NServiceBus.Features;
using NServiceBus.Persistence;

namespace ConsoleApp5
{
    class Program
    {
        static void Main(string[] args)
        {
            MainAsync().Wait();
        }

        static async Task MainAsync()
        {
            var sourceQueue = "Queue";
            var storageConnectionString = "paste your connectionstring here";
            var endpointConfiguration = new EndpointConfiguration(sourceQueue);
            var persistence = endpointConfiguration.UsePersistence<AzureStoragePersistence>();
            persistence.ConnectionString(storageConnectionString);
            endpointConfiguration.UsePersistence<AzureStoragePersistence, StorageType.Sagas>()
                .AssumeSecondaryIndicesExist();
            endpointConfiguration.UsePersistence<AzureStoragePersistence, StorageType.Subscriptions>();
            endpointConfiguration.UseSerialization<JsonSerializer>();
            endpointConfiguration.EnableInstallers();
            endpointConfiguration.SendFailedMessagesTo("error");
            endpointConfiguration.SendOnly();
            var transport = endpointConfiguration.UseTransport<NServiceBus.AzureStorageQueueTransport>();
            transport.ConnectionString(storageConnectionString);
            endpointConfiguration.DisableFeature<TimeoutManager>();
            endpointConfiguration.UseSerialization<JsonSerializer>();
            var endpointInstance = await Endpoint.Start(endpointConfiguration)
                .ConfigureAwait(false);

            Console.ReadLine();
            //await endpointInstance.Stop()
            //    .ConfigureAwait(false);

        }
    }
}
